import { FactoryResolver } from './factory';
import { InvocableResolver } from './invocable';
import { Injection } from './injection';
export default class Container<Specifier, T> {
    private _factoryResolver;
    private _invocableResolver;
    constructor(factoryResolver?: FactoryResolver<Specifier, T>, invocableResolver?: InvocableResolver<Specifier>);
    lookup(specifier: Specifier, constructorArgs?: any[]): T;
    teardown(specifier: Specifier, instance?: any): void;
    invoke(specifier: Specifier, args?: any[]): any;
    evaluateInjection(injection: Injection<Specifier>): any;
    private evaluateStaticInjection(injection);
    private evaluateCreatableInjection(injection);
    private evaluatePropertyInjection(injection);
    private evaluateMethodInjection(injection);
    private evaluateInvocableInjection(injection);
    private evaluateDictionaryInjection(injection);
    private evaluateObjectInjection(injection);
    private evaluateArrayInjection(injection);
}
