import { Invocable, InvocableResolver } from './invocable';
import { Injection } from './injection';
import { SpecifierResolver } from './specifier';
export default class InvocableRegistry<Specifier> implements InvocableResolver<Specifier> {
    private _specifierResolver;
    private _invocables;
    private _invocableArguments;
    constructor(specifierResolver: SpecifierResolver<Specifier>);
    registerInvocable(specifier: Specifier, invocable: Invocable): void;
    unregisterInvocable(specifier: Specifier): void;
    invocableFor(specifier: Specifier): Invocable;
    registerInvocableArguments(specifier: Specifier, args: Injection<Specifier>[]): void;
    unregisterInvocableArguments(specifier: Specifier): void;
    invocableArgumentsFor(specifier: Specifier): Injection<Specifier>[];
    retrieveInvocable(specifier: Specifier): Invocable;
    retrieveInvocableArguments(specifier: Specifier): Injection<Specifier>[];
}
